import java.lang.*;
import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Statistics.*;

public class Job {
    
    public Job (int nodoIni,int nodoFin) {
	ResponseTime = 0.0;
	ArrivalTime = Scheduler.CurrentTime();
	MachineShop.TotalJobs++;
	nodoInicial=nodoIni;
	nodoFinal=nodoFin;
    }
   
    public void finished () {
	// destructor de la clase, calcula el tiempo de respuesta 
	// y los trabajos borrados
	MachineShop.ErasedJobs++;
	if ( MachineShop.TotalJobs > MachineShop.TRANSITORIO) {
	    // al superar el transitorio guardo los datos
	    ResponseTime = Scheduler.CurrentTime() - ArrivalTime;
	    MachineShop.TotalResponseTime += ResponseTime;
	    MachineShop.meanDelay.setValue( ResponseTime );
	}
    }
    
    public int HostInicial() { 
	return nodoInicial;
    }
    
    public int HostFinal() { 
	return nodoFinal;
    }
    
    private double ResponseTime;
    private double ArrivalTime;
    private int nodoInicial;
    private int nodoFinal;
    
};
