package arjuna.JavaSim.Simulation;

/** 
    Excepciones que se producen en el paquete "Simulation".
    La excepcin se lanza cuando hay alguna situacin anormal en la 
    simulacin, por ejemplo, algn mtodo no se usa correctamente.
    Es recomendable que los bloques que tratan esta excepcin muestren
    un mensaje indicando que se produce una excepcin.
    De este modo, se evitarn posibles simulaciones infinitas, que no se 
    sabe porqu no finalizan.
*/

public class SimulationException extends Exception
{

public SimulationException ()
    {
	super();
    }

public SimulationException (String s)
    {
	super(s);
    }

};
